// -*- c++ -*-

/*
    Copyright (C) 2009  David Psenicka
    This file is part of FOMUS.

    FOMUS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FOMUS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FOMUS_INFOEXTAPI_H
#define FOMUS_INFOEXTAPI_H

#include "infoapi.h"

#ifdef __cplusplus
extern "C" {
#endif

  struct infoext_objinfo {
    module_obj obj;
    struct module_value val;
    const char* valstr;
  };
  struct infoext_objinfo_list {
    int n;
    struct infoext_objinfo *objs;
  };

#ifndef LIBFOMUS_HIDE
  
  // Extended info API
  LIBFOMUS_EXPORT const struct info_setlist infoext_list_settings(module_obj o); 
  LIBFOMUS_EXPORT const struct info_marklist infoext_list_marks();

  LIBFOMUS_EXPORT const struct infoext_objinfo_list infoext_list_percinsts(FOMUS f);
  LIBFOMUS_EXPORT const struct infoext_objinfo_list infoext_list_insts(FOMUS f);
  LIBFOMUS_EXPORT const struct infoext_objinfo_list infoext_list_parts(FOMUS f);
  LIBFOMUS_EXPORT const struct infoext_objinfo_list infoext_list_metaparts(FOMUS f);
  //LIBFOMUS_EXPORT const struct infoext_objinfo_list infoext_list_partsrefs(FOMUS f);
  LIBFOMUS_EXPORT const struct infoext_objinfo_list infoext_list_measdefs(FOMUS f);

  LIBFOMUS_EXPORT const char* infoext_valstr(module_obj obj); // returns "" if default, "id" if has id, or full def if no id--use module_free_string to free it

  LIBFOMUS_EXPORT struct infoext_objinfo infoext_getlastentry(FOMUS f); // if one of the above has been entered, this gets the last entry (so frontend can redisplay it, etc..)

#endif
  
#ifdef __cplusplus
}
#endif  

#endif
