// -*- c++ -*-

/*
    Copyright (C) 2009  David Psenicka
    This file is part of FOMUS.

    FOMUS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FOMUS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FOMUS_MODDIVIDE_H
#define FOMUS_MODDIVIDE_H

#include "module.h"
#include "modnotes.h" // common functions for all modules modifying notes
#include "modmod.h"

#ifdef __cplusplus
extern "C" {
#endif

  struct divide_tuplet {
    struct fomus_rat tuplet;
    int begin, end;
    struct fomus_rat fulldur;
  };
  struct divide_split {
    module_noteobj note;
    struct fomus_rat time; //, endtime;
    int n; // outer to inner
    struct divide_tuplet* tups;
  };
//   struct divide_splits {
//     int n;
//     divide_split* splits;
//   };

  // initdivs are the initial measure divisions
  LIBFOMUS_EXPORT void divide_assign_initdivs(module_measobj meas, struct module_ratslist initdivs); // called once per measure
  LIBFOMUS_EXPORT void divide_assign_split(module_measobj meas, struct divide_split split);
  //void divide_assign_done(module_measobj meas); don't really need it--module needs to do assignskip on all notes
  
#ifdef __cplusplus
}
#endif

#endif
