// -*- c++ -*-

/*
    Copyright (C) 2009  David Psenicka
    This file is part of FOMUS.

    FOMUS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FOMUS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FOMUS_MODENUMS_H
#define FOMUS_MODENUMS_H

#ifdef __cplusplus
extern "C" {
#endif

  enum parts_grouptype {
    parts_nogroup,
    parts_group,
    parts_choirgroup,
    parts_grandstaff
  };

  enum module_clefids {
    clef_subbass_8down,
    clef_bass_8down,
    clef_c_baritone_8down,
    clef_f_baritone_8down,
    clef_tenor_8down,
    clef_subbass,
    clef_alto_8down,
    clef_bass,
    clef_mezzosoprano_8down,
    clef_c_baritone,
    clef_f_baritone,
    clef_soprano_8down,
    clef_tenor,
    clef_subbass_8up,
    clef_treble_8down,
    clef_alto,
    clef_bass_8up,
    clef_mezzosoprano,
    clef_c_baritone_8up,
    clef_f_baritone_8up,
    clef_soprano,
    clef_tenor_8up,
    clef_treble,
    clef_alto_8up,
    clef_mezzosoprano_8up,
    clef_soprano_8up,
    clef_treble_8up,
    clef_percussion,
    clef_nclefs
  };
  
  enum module_markids {
    mark_staccato,
    mark_staccatissimo,
    mark_accent,
    mark_tenuto,
    mark_marcato,
    mark_mezzostaccato,
    mark_open,
    mark_harm,
    mark_stopped,
    mark_pizz,
    mark_arco,
    mark_fermata,
    mark_arpeggio,
    mark_gliss,
    mark_port,
    mark_breath,
    mark_trem,
    mark_ltrem,
    mark_rtrem,
    mark_sounding,
    mark_touched,
    mark_played,
    mark_string,
    mark_sul,
    mark_sf,
    mark_sff,
    mark_sfff,
    mark_sfz,
    mark_sffz,
    mark_sfffz,
    mark_fz,
    mark_ffz,
    mark_fffz,
    mark_rfz,
    mark_rf,
    mark_pppppp,
    mark_ppppp,
    mark_pppp,
    mark_ppp,
    mark_pp,
    mark_p,
    mark_mp,
    mark_ffff,
    mark_fff,
    mark_ff,
    mark_f,
    mark_mf,
    mark_slur_begin,
    mark_slur_end,
    mark_phrase_begin,
    mark_phrase_end,
    mark_graceslur_begin,
    mark_graceslur_end,
    mark_text,
    mark_text_begin,
    mark_text_end,
    mark_cresc_begin,
    mark_cresc_end,
    mark_dim_begin,
    mark_dim_end,
    mark_tie,
    mark_nmarks
  };

#ifdef __cplusplus
}
#endif  

#endif
