// -*- c++ -*-

/*
    Copyright (C) 2009  David Psenicka
    This file is part of FOMUS.

    FOMUS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FOMUS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FOMUS_MODIN_H
#define FOMUS_MODIN_H

#include "basetypes.h"
#include "modinout.h"
#include "modnotes.h"
#include "modinit.h"

#ifdef __cplusplus
extern "C" {
#endif

  // import structures
  LIBFOMUS_EXPORT const char* modin_importpercid(module_obj imp);
  
  struct modin_imports {
    int n;
    const module_obj* obj;
  };
  LIBFOMUS_EXPORT struct modin_imports modin_imports(module_partobj part);

#ifndef FOMUSMOD_HIDE
  
  // CALLBACKS
  // return lowercase filename extension strings (0 when the last is reached)
  FOMUSMOD_EXPORT const char* modin_get_extension(int n);
  // return a loadid that can be used instead of a filename extension (this is checked first!)--return 0 if none (=file input)
  FOMUSMOD_EXPORT const char* modin_get_loadid(); // for non-file types, return a string identifier (ex. midiin...) not implemented yet

  // data is data object returned by newdata function
  // filename is complete (and should be in OS's native format) and exists
  // return true on success
  FOMUSMOD_EXPORT int modin_load(FOMUS f, void* data, const char* text, int isfile);

#endif
  
#ifdef __cplusplus
}
#endif

#endif
