// -*- c++ -*-

/*
    Copyright (C) 2009  David Psenicka
    This file is part of FOMUS.

    FOMUS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FOMUS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FOMUS_MODMOD_H
#define FOMUS_MODMOD_H

#include "modinit.h"

// most modules should include this so that they can hook up with an engine

#ifdef __cplusplus
extern "C" {
#endif

#ifndef FOMUSMOD_HIDE
  
  // how module wants its data
  FOMUSMOD_EXPORT int module_itertype();
  
  FOMUSMOD_EXPORT int module_engine_iface(); // what engine does the module want?
  FOMUSMOD_EXPORT void module_fill_iface(void* moddata, void* iface); // module
  FOMUSMOD_EXPORT const char* module_engine(void* moddata); // what engine module to use?
  
  FOMUSMOD_EXPORT int module_priority();

  // module compares settings in a and b and returns true if instance should be the same
  FOMUSMOD_EXPORT int module_sameinst(module_obj a, module_obj b);

#endif
  
#ifdef __cplusplus
}
#endif

#endif
