// -*- c++ -*-

/*
    Copyright (C) 2009  David Psenicka
    This file is part of FOMUS.

    FOMUS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FOMUS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FOMUS_MODMPARTS_H
#define FOMUS_MODMPARTS_H

#include "module.h"
#include "modnotes.h"
#include "modmod.h"

#ifdef __cplusplus
extern "C" {
#endif

  typedef void* metaparts_partmapobj;
  struct metaparts_partmaps {
    int n;
    const metaparts_partmapobj* partmaps;
  };
  LIBFOMUS_EXPORT struct metaparts_partmaps metaparts_getpartmaps(module_partobj part);
  LIBFOMUS_EXPORT module_partobj metaparts_partmappart(metaparts_partmapobj partsmap);
  LIBFOMUS_EXPORT int metaparts_ismetapart(module_partobj part);
  
  LIBFOMUS_EXPORT void metaparts_assign(module_noteobj note, module_partobj part, int voice, struct fomus_rat pitch);
  LIBFOMUS_EXPORT void metaparts_assign_done(module_noteobj note);
  
#ifdef __cplusplus
}
#endif

#endif
