// -*- c++ -*-

/*
    Copyright (C) 2009  David Psenicka
    This file is part of FOMUS.

    FOMUS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FOMUS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FOMUS_MODTQUANT_H
#define FOMUS_MODTQUANT_H

#include "module.h"
#include "modnotes.h" // common functions for all modules modifying notes
#include "modmod.h"

#ifdef __cplusplus
extern "C" {
#endif

  // for both grace and non-grace notes--dur is ignored for grace notes
  // if this is used, another module must handle grace notes!
  LIBFOMUS_EXPORT void tquant_assign_time(module_noteobj note, struct fomus_rat time, struct fomus_rat dur); // fomus protects grace notes from having durations overwritten
  // special for grace notes
  LIBFOMUS_EXPORT void tquant_assign_gracetime(module_noteobj note, struct fomus_rat time, struct module_value gracetime, struct module_value dur); 

  LIBFOMUS_EXPORT void tquant_delete(module_noteobj note); // user might want notes deleted if their durations quantize to 0

#ifdef __cplusplus
}
#endif

#endif
